module Push
  module Igetui
    module List
      def data_hash(user_device_ids, template_data = {}, igetui_opts = {})
        # 包装成igetui 真正需要的参数格式
        igetui_opts = HashWithIndifferentAccess.new(igetui_opts)
        igetui_opts[:transmission_content] = template_data
        if user_device_ids.size > 1
          transmission_to_list_igetui(igetui_opts)
        else
          transmission_to_igetui(igetui_opts)
        end
      rescue StandardError => err
        ::Push::Log.error(err)
      end

      def config
        {
          push_type: 2
        }
      end
  
      def transmission_to_igetui(template_data = {})
        template_data = handle_template_data(template_data)
        
       {template_data: template_data, template_type: 'TransmissionTemplate'}
      end
  
      def transmission_to_list_igetui(template_data = {})
        template_data = handle_template_data(template_data)
        
        {template_data: template_data, template_type: 'TransmissionTemplate', pusher_type: 'push_message_to_list'}
      end
  
      private
  
      def handle_template_data(template_data)
        template_data = HashWithIndifferentAccess.new(template_data)
        transmission_content = HashWithIndifferentAccess.new(template_data.delete(:transmission_content))
        transmission_content[:push_type] ||= config[:push_type]
        template_data[:transmission_type] ||= 0
        template_data[:transmission_content] = transmission_content.as_json
        template_data
      end
    end
  end
end