#通过组合模块的形式，将这个类赋予了推送的数据结构组合的功能，底层推送代码的功能等
module Push
  class IgetuiIos
    include Push::Igetui::Base
    include Push::Igetui::List
  
    PUSHERTYPES = %w[push_message_to_single push_message_to_list push_message_to_app].freeze
    TEMPLATETYPES = %w[LinkTemplate NotificationTemplate TransmissionTemplate NotyPopLoadTemplate].freeze

    def initialize(user_device_ids, opts)
      opts = HashWithIndifferentAccess.new(opts)
      @template_data = opts[:template_data]
      @igetui_opts = opts[:igetui_opts]
      @user_device_ids = user_device_ids
    end



    def push
      data_hash_opts = data_hash(@user_device_ids, @template_data, @igetui_opts)
  
      pusher_type = PUSHERTYPES.include?((data_hash_opts[:pusher_type]).to_s) ? data_hash_opts[:pusher_type] : 'push_message_to_single'
      template_type = TEMPLATETYPES.include?((data_hash_opts[:template_type]).to_s) ? data_hash_opts[:template_type] : 'NotificationTemplate'
      template_data = data_hash_opts[:template_data]

      result = push_message_to(pusher, pusher_type, template_type, template_data, @user_device_ids)
      ::Push::Log.info("igetui_push: \n template_data: #{template_data}\n user_device_ids: #{@user_device_ids}\n response: #{result}")
    end

    private

    def pusher
      @pusher ||=
        IGeTui.pusher(
          Settings.platform_settings.igetui.ios['app_id'],
          Settings.platform_settings.igetui.ios['app_key'],
          Settings.platform_settings.igetui.ios['master_secret']
        )
    end

  end
end
