#push功能的代理选择用哪种推送工具1.个推 2.小米 3.华为
class PushToolClient
  
  def initialize(opts={})
    @user_ids = opts[:user_ids]
    @opts = opts
  end

  def do_push
    @push_collections ||= push_collections

    Push::IgetuiIos.new(@push_collections[:igetui_ios], @opts).push if @push_collections[:igetui_ios].present?
    Push::IgetuiAndroid.new(@push_collections[:igetui_android], @opts).push if @push_collections[:igetui_android].present?

    #现在好像不用了
    # Push::IgetuiIos.push(@push_collections[:igetui_ios], @opts) if @push_collections[:apns].present?
    # Push::IgetuiAndroid.push(@push_collections[:igetui_android], @opts) if @push_collections[:apns].present?

    Push::Xiaomi.push(@push_collections[:xiaomi], @opts[:message]) if @push_collections[:xiaomi].present?
    Push::Huawei.push(@push_collections[:huawei], @opts[:message]) if @push_collections[:huawei].present?
  end

  private
  
  def push_collections
    _push_collection = {
      igetui_ios: [],
      igetui_android: [],
      apns: [],
      xiaomi: [],
      huawei: []
    }

    user_devices = UserDevice.where(user_id: @user_ids)

    user_devices.each do |user_device|
      client_id = user_device.client_id

      case user_device.platform
        when 'igetui'
         if user_device.device_platform == 'ios'
           _push_collection[:igetui_ios] << client_id
         else
           _push_collection[:igetui_ios] << client_id
         end
        when 'apns'
          _push_collection[:apns] << client_id
        when 'xiaomi'
          _push_collection[:xiaomi] << client_id
        when 'huawei'
          _push_collection[:huawei] << client_id
      end
    end
  end

  
end