module Token
  ACCESS_TOEKN_EXPIRE_TIME = 7200
  class << self
    def key(app_name)
      "push:api:#{app_name}:access_token"
    end

    def generate_token(app_name)
      token = SecureRandom.hex(32)
      $redis.set(key(app_name), token, ex: ACCESS_TOEKN_EXPIRE_TIME)
      token
    end

    def token(app_name)
      $redis.get(key(app_name))
    end

    def ttl(app_name)
      $redis.ttl(key(app_name))
    end
  end
end